Index: LMDZ5/branches/testing/libf/phylmd/phytrac.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phytrac.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/phytrac.F90	(revision 1750)
@@ -3,5 +3,5 @@
 SUBROUTINE phytrac(                            &
      nstep,     julien,   gmtime,   debutphy,  &
-     lafin,     pdtphys,  u, v,     t_seri,     &
+     lafin,     pdtphys,  u, v,     t_seri,    &
      paprs,     pplay,    pmfu,     pmfd,      &
      pen_u,     pde_u,    pen_d,    pde_d,     &
@@ -9,5 +9,6 @@
      yu1,       yv1,      ftsol,    pctsrf,    &
      ustar,     u10m,      v10m,               &
-     xlat,      frac_impa,frac_nucl,xlon,      &
+     xlat,      xlon,                          &
+     frac_impa,frac_nucl,beta_fisrt,beta_v1,   &
      presnivs,  pphis,    pphi,     albsol,    &
      sh,        rh,       cldfra,   rneb,      &
@@ -15,7 +16,11 @@
      pmflxr,    pmflxs,   prfl,     psfl,      &
      da,        phi,      mp,       upwd,      &
+     phi2,      d1a,      dam,      sij,       &   ! RomP
+     wdtrainA,  wdtrainM, sigd,     clw,elij,  &   ! RomP 
+     evap,      ep,       epmlmMm,  eplaMm,    &   ! RomP
      dnwd,      aerosol_couple,     flxmass_w, &
      tau_aero,  piz_aero,  cg_aero, ccm,       &
      rfname,                                   &
+     d_tr_dyn,                                 &   ! RomP
      tr_seri)         
 !
@@ -23,7 +28,11 @@
 ! Auteur(s) FH
 ! Objet: Moniteur general des tendances traceurs
+! Modification R. Pilon 01 janvier 2012 transport+scavenging KE scheme : cvltr
+! Modification R. Pilon 10 octobre 2012 large scale scavenging incloud_scav + bc_scav
 !======================================================================
 
   USE ioipsl
+  USE phys_cal_mod, only : hour
+  USE phys_output_mod, only : convers_timesteps
   USE dimphy
   USE infotrac
@@ -36,5 +45,4 @@
   USE tracreprobus_mod
   USE control_mod
-
 
   IMPLICIT NONE
@@ -68,6 +76,6 @@
 !--------
   REAL,DIMENSION(klon,klev),INTENT(IN)   :: t_seri  ! Temperature
-  REAL,DIMENSION(klon,klev),INTENT(IN)   :: u       ! variable not used
-  REAL,DIMENSION(klon,klev),INTENT(IN)   :: v       ! variable not used
+  REAL,DIMENSION(klon,klev),INTENT(IN)   :: u       ! variable not used 
+  REAL,DIMENSION(klon,klev),INTENT(IN)   :: v       ! variable not used 
   REAL,DIMENSION(klon,klev),INTENT(IN)   :: sh      ! humidite specifique
   REAL,DIMENSION(klon,klev),INTENT(IN)   :: rh      ! humidite relative
@@ -81,7 +89,17 @@
   REAL,DIMENSION(klon,klev),INTENT(IN)   :: diafra  ! fraction nuageuse (convection ou stratus artificiels)
   REAL,DIMENSION(klon,klev),INTENT(IN)   :: rneb    ! fraction nuageuse (grande echelle)
+!
+  REAL                                   :: ql_incl ! contenu en eau liquide nuageuse dans le nuage ! ql_incl=oliq/rneb
+  REAL,DIMENSION(klon,klev),INTENT(IN)   :: beta_fisrt ! taux de conversion de l'eau cond (de fisrtilp)
+  REAL,DIMENSION(klon,klev),INTENT(out)  :: beta_v1    ! -- (originale version)
+
+!
   INTEGER,DIMENSION(klon),INTENT(IN)     :: itop_con
   INTEGER,DIMENSION(klon),INTENT(IN)     :: ibas_con
   REAL,DIMENSION(klon),INTENT(IN)        :: albsol  ! albedo surface
+!
+!Dynamique
+!--------
+  REAL,DIMENSION(klon,klev,nbtr),INTENT(IN)    :: d_tr_dyn
 !
 !Convection:
@@ -108,4 +126,22 @@
   REAL,DIMENSION(klon,klev),INTENT(IN)     :: da
   REAL,DIMENSION(klon,klev,klev),INTENT(IN):: phi
+! RomP >>>
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: d1a,dam
+  REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: phi2
+!
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: wdtrainA
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: wdtrainM
+  REAL,DIMENSION(klon),INTENT(IN)           :: sigd
+! ---- RomP flux entraine, detraine et precipitant kerry Emanuel
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: evap
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: ep
+  REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: sij
+  REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: elij
+  REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: epmlmMm
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: eplaMm
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: clw
+! RomP <<<
+
+!
   REAL,DIMENSION(klon,klev),INTENT(IN)     :: mp
   REAL,DIMENSION(klon,klev),INTENT(IN)     :: upwd      ! saturated updraft mass flux
@@ -120,9 +156,9 @@
 !--------------
 !
-  REAL,DIMENSION(klon),INTENT(IN)     :: cdragh ! coeff drag pour T et Q
-  REAL,DIMENSION(klon,klev),INTENT(IN):: coefh  ! coeff melange CL (m**2/s)
-  REAL,DIMENSION(klon),INTENT(IN)     :: ustar,u10m,v10m ! u* & vent a 10m (m/s)
-  REAL,DIMENSION(klon),INTENT(IN)     :: yu1    ! vents au premier niveau
-  REAL,DIMENSION(klon),INTENT(IN)     :: yv1    ! vents au premier niveau
+  REAL,DIMENSION(klon),INTENT(IN)      :: cdragh ! coeff drag pour T et Q
+  REAL,DIMENSION(klon,klev),INTENT(IN) :: coefh  ! coeff melange CL (m**2/s)
+  REAL,DIMENSION(klon),INTENT(IN)      :: ustar,u10m,v10m ! u* & vent a 10m (m/s)
+  REAL,DIMENSION(klon),INTENT(IN)      :: yu1    ! vents au premier niveau
+  REAL,DIMENSION(klon),INTENT(IN)      :: yv1    ! vents au premier niveau
 !
 !Lessivage:
@@ -141,6 +177,6 @@
 ! Output argument
 !----------------
-  REAL,DIMENSION(klon,klev,nbtr),INTENT(INOUT) :: tr_seri ! Concentration Traceur [U/KgA]  
-
+  REAL,DIMENSION(klon,klev,nbtr),INTENT(INOUT) :: tr_seri ! Concentration Traceur [U/KgA]
+  REAL,DIMENSION(klon,klev)                    :: sourceBE 
 !=======================================================================================
 !                        -- LOCAL VARIABLES --
@@ -153,5 +189,5 @@
 !--------------------------------------------
 !
-  REAL,DIMENSION(:,:),ALLOCATABLE,SAVE :: source  ! a voir lorsque le flux de surface est prescrit 
+  REAL,DIMENSION(:,:),ALLOCATABLE,SAVE :: source  ! a voir lorsque le flux de surface est prescrit
 !$OMP THREADPRIVATE(source)
 
@@ -166,5 +202,6 @@
   REAL,DIMENSION(klon)      :: zx_tmp_fi2d ! variable temporaire grille physique
   INTEGER                   :: itau_w      ! pas de temps ecriture = nstep + itau_phy
-  LOGICAL,PARAMETER :: ok_sync=.TRUE.
+  LOGICAL,PARAMETER         :: ok_sync=.TRUE.
+  CHARACTER(len=20)         :: chtratimestep 
 
 !
@@ -175,19 +212,46 @@
   REAL,DIMENSION(klon,klev)             :: delp     ! epaisseur de couche (Pa)
 !
-! Tendances de traceurs (Td):
+! Tendances de traceurs (Td) et flux de traceurs:
 !------------------------
-!
   REAL,DIMENSION(klon,klev)      :: d_tr     ! Td dans l'atmosphere
   REAL,DIMENSION(klon,klev,nbtr) :: d_tr_cl  ! Td couche limite/traceur
+  REAL,DIMENSION(klon,nbtr)      :: d_tr_dry ! Td depot sec/traceur (1st layer)  jyg
+  REAL,DIMENSION(klon,nbtr)      :: flux_tr_dry ! depot sec/traceur (surface)    jyg
+  REAL,DIMENSION(klon,klev,nbtr) :: d_tr_dec                            !RomP
   REAL,DIMENSION(klon,klev,nbtr) :: d_tr_cv  ! Td convection/traceur
+! RomP >>>
+  REAL,DIMENSION(klon,klev,nbtr) :: d_tr_insc
+  REAL,DIMENSION(klon,klev,nbtr) :: d_tr_bcscav
+  REAL,DIMENSION(klon,klev,nbtr) :: d_tr_evapls
+  REAL,DIMENSION(klon,klev,nbtr) :: d_tr_ls
+  REAL,DIMENSION(klon,nbtr)      :: qPrls      !jyg: concentration tra dans pluie LS a la surf.
+  REAL,DIMENSION(klon,klev,nbtr) :: d_tr_trsp
+  REAL,DIMENSION(klon,klev,nbtr) :: d_tr_sscav
+  REAL,DIMENSION(klon,klev,nbtr) :: d_tr_sat
+  REAL,DIMENSION(klon,klev,nbtr) :: d_tr_uscav
+  REAL,DIMENSION(klon,klev,nbtr) :: qPr,qDi ! concentration tra dans pluie,air descente insaturee
+  REAL,DIMENSION(klon,klev,nbtr) :: qPa,qMel
+  REAL,DIMENSION(klon,klev,nbtr) :: qTrdi,dtrcvMA ! conc traceur descente air insaturee et td convective MA
+  REAL,DIMENSION(klon,klev)      :: Mint
+  REAL,DIMENSION(klon,klev,nbtr) :: zmfd1a
+  REAL,DIMENSION(klon,klev,nbtr) :: zmfdam
+  REAL,DIMENSION(klon,klev,nbtr) :: zmfphi2
+! RomP <<<
   REAL,DIMENSION(klon,klev,nbtr) :: d_tr_th  ! Td thermique
   REAL,DIMENSION(klon,klev,nbtr) :: d_tr_lessi_impa ! Td du lessivage par impaction
-  REAL,DIMENSION(klon,klev,nbtr) :: d_tr_lessi_nucl ! Td du lessivage par nucleation 
+  REAL,DIMENSION(klon,klev,nbtr) :: d_tr_lessi_nucl ! Td du lessivage par nucleation
 !
 ! Physique
-!----------   
+!---------- 
   REAL,DIMENSION(klon,klev,nbtr) :: flestottr ! flux de lessivage dans chaque couche 
   REAL,DIMENSION(klon,klev)      :: zmasse    ! densité atmosphérique Kg/m2
   REAL,DIMENSION(klon,klev)      :: ztra_th
+!PhH
+  REAL,DIMENSION(klon,klev)      :: zrho
+  REAL,DIMENSION(klon,klev)      :: zdz
+  REAL                           :: evaplsc,dx,beta ! variable pour lessivage Genthon
+  REAL,DIMENSION(klon)           :: his_dh          ! ---
+! in-cloud scav variables
+  REAL           :: ql_incloud_ref     ! ref value of in-cloud condensed water content
   
 !Controles:
@@ -199,11 +263,89 @@
 
   CHARACTER(len=8),DIMENSION(nbtr) :: solsym
-
-
+!RomP >>>
+  INTEGER,SAVE  :: iflag_lscav
+  LOGICAL,SAVE  :: convscav
+!$OMP THREADPRIVATE(iflag_lscav,convscav)
+!RomP <<<
 !######################################################################
 !                    -- INITIALIZATION --
 !######################################################################
+  DO k=1,klev
+     DO i=1,klon
+      sourceBE(i,k)=0.
+      Mint(i,k)=0.
+      zrho(i,k)=0.
+      zdz(i,k)=0.
+     END DO
+  END DO
+
+  DO it=1, nbtr
+   DO k=1,klev
+    DO i=1,klon
+    d_tr_insc(i,k,it)=0.
+    d_tr_bcscav(i,k,it)=0.
+    d_tr_evapls(i,k,it)=0.
+    d_tr_ls(i,k,it)=0.
+    d_tr_cv(i,k,it)=0.
+    d_tr_cl(i,k,it)=0.
+    d_tr_trsp(i,k,it)=0.
+    d_tr_sscav(i,k,it)=0.
+    d_tr_sat(i,k,it)=0.
+    d_tr_uscav(i,k,it)=0.
+    d_tr_lessi_impa(i,k,it)=0.
+    d_tr_lessi_nucl(i,k,it)=0.
+    qDi(i,k,it)=0.
+    qPr(i,k,it)=0.
+    qPa(i,k,it)=0.
+    qMel(i,k,it)=0.
+    qTrdi(i,k,it)=0.
+    dtrcvMA(i,k,it)=0.
+    zmfd1a(i,k,it)=0.
+    zmfdam(i,k,it)=0.
+    zmfphi2(i,k,it)=0.
+    END DO
+   END DO
+  END DO
   IF (debutphy) THEN
-     IF (prt_level >9) WRITE(lunout,*) 'FIRST TIME IN PHYTRAC : pdtphys(sec) = ',pdtphys,'ecrit_tra (sec) = ',ecrit_tra
+!!jyg
+   chtratimestep='DefFreq'
+   CALL getin('tra_time_step',chtratimestep)
+   IF (chtratimestep .NE. 'DefFreq') THEN
+     call convers_timesteps(chtratimestep,pdtphys,ecrit_tra)
+   ENDIF
+!RomP >>>
+!
+!Config Key  = convscav
+!Config Desc = Convective scavenging switch: 0=off, 1=on.
+!Config Def  = .false.
+!Config Help = 
+!
+  convscav=.false.
+  call getin('convscav', convscav)
+  print*,'phytrac passage dans routine conv avec lessivage', convscav
+!
+!Config Key  = iflag_lscav
+!Config Desc = Large scale scavenging parametrization: 0=none, 1=old(Genthon92),
+!              2=1+PHeinrich, 3=Reddy_Boucher2004, 4=3+RPilon.
+!Config Def  = 1
+!Config Help = 
+!
+  iflag_lscav=1
+  call getin('iflag_lscav', iflag_lscav)
+!
+  SELECT CASE(iflag_lscav)
+  CASE(0)
+   PRINT*, 'Large scale scavenging: none'
+  CASE(1)
+   PRINT*, 'Large scale scavenging: C. Genthon, Tellus(1992), 44B, 371-389'
+  CASE(2)
+   PRINT*, 'Large scale scavenging: C. Genthon, modified P. Heinrich'
+  CASE(3)
+   PRINT*, 'Large scale scavenging: M. Shekkar Reddy and O. Boucher, JGR(2004), 109, D14202'
+  CASE(4)
+   PRINT*, 'Large scale scavenging: Reddy and Boucher, modified R. Pilon'
+  END SELECT
+!RomP <<<
+     WRITE(*,*) 'FIRST TIME IN PHYTRAC : pdtphys(sec) = ',pdtphys,'ecrit_tra (sec) = ',ecrit_tra
      ALLOCATE( source(klon,nbtr), stat=ierr)
      IF (ierr /= 0) CALL abort_gcm('phytrac', 'pb in allocation 1',1)
@@ -237,4 +379,12 @@
      END DO
   END DO
+!
+  IF (id_be .GT. 0) THEN
+  DO k=1,klev
+     DO i=1,klon
+        sourceBE(i,k)=srcbe(i,k)       !RomP  -> pour sortie histrac
+     END DO
+  END DO
+  ENDIF
 
 !===============================================================================
@@ -246,7 +396,8 @@
      !    -- Traitement des traceurs avec traclmdz
      CALL traclmdz(nstep, julien, gmtime, pdtphys, t_seri, paprs, pplay, &
-          cdragh,  coefh, yu1, yv1, ftsol, pctsrf, xlat, xlon,couchelimite,sh,&
+          cdragh,  coefh, yu1, yv1, ftsol, pctsrf, xlat, xlon,couchelimite,sh, &
           rh, pphi, ustar, u10m, v10m, &
-          tr_seri, source, solsym, d_tr_cl, zmasse)
+!!          tr_seri, source, solsym, d_tr_cl, zmasse)                      !RomP
+          tr_seri, source, solsym, d_tr_cl,d_tr_dec, zmasse)               !RomP
   CASE('inca')
      !    -- CHIMIE INCA  config_inca = aero or chem --
@@ -273,23 +424,35 @@
      
   END SELECT
-
 !======================================================================
 !       -- Calcul de l'effet de la convection --
 !======================================================================
+
   IF (convection) THEN
      DO it=1, nbtr
         IF ( conv_flg(it) == 0 ) CYCLE
-        
         IF (iflag_con.LT.2) THEN
-           d_tr_cv(:,:,:)=0.
+           d_tr_cv(:,:,it)=0.
         ELSE IF (iflag_con.EQ.2) THEN
 !..Tiedke
            CALL nflxtr(pdtphys, pmfu, pmfd, pen_u, pde_u, pen_d, pde_d, &
                 pplay, paprs, tr_seri(:,:,it), d_tr_cv(:,:,it))
-        ELSE
-!..K.Emanuel
-           CALL cvltr(pdtphys, da, phi, mp, paprs,pplay, tr_seri(:,:,it),&
-                upwd,dnwd,d_tr_cv(:,:,it))
+! RomP >>>                
+        ELSE   
+!..K.Emanuel                  !RomP modif arg
+        if (convscav.and.aerosol(it)) then    ! lessivage convectif pour aerosol
+!
+          CALL cvltr(pdtphys, da, phi,phi2,d1a,dam, mp,ep,              &
+               sigd,sij,clw,elij,epmlmMm,eplaMm,                        &
+               pmflxr,pmflxs,evap,t_seri,wdtrainA,wdtrainM,             &   
+               paprs,it,tr_seri,upwd,dnwd,itop_con,ibas_con,            &
+               d_tr_cv,d_tr_trsp,d_tr_sscav,d_tr_sat,d_tr_uscav,qDi,qPr,&
+               qPa,qMel,qTrdi,dtrcvMA,Mint,                             &
+               zmfd1a,zmfphi2,zmfdam)
+        else  !pas de lessivage convectif ou n'est pas un aerosol
+           CALL cvltrorig(it,pdtphys, da, phi,mp,paprs,pplay,tr_seri,&
+                    upwd,dnwd,d_tr_cv)
+        endif
         END IF
+! RomP <<<
 
         DO k = 1, klev
@@ -357,5 +520,5 @@
                 tr_seri(:,:,it), source(:,it),      &
                 paprs, pplay, delp,                 &
-                d_tr_cl(:,:,it))
+                d_tr_cl(:,:,it),d_tr_dry(:,it),flux_tr_dry(:,it))
            
            DO k = 1, klev
@@ -372,9 +535,109 @@
 
 !======================================================================
-!   Calcul de l'effet de la precipitation
-!======================================================================
-
+!   Calcul de l'effet de la precipitation grande echelle
+!======================================================================
   IF (lessivage) THEN
-     
+
+   ql_incloud_ref = 10.e-4
+   ql_incloud_ref =  5.e-4
+
+
+! calcul du contenu en eau liquide au sein du nuage
+     ql_incl = ql_incloud_ref
+! choix du lessivage
+!
+  IF (iflag_lscav .EQ. 3 .OR. iflag_lscav .EQ. 4) THEN
+! ********  Olivier Boucher version (3) possibly with modified ql_incl (4)
+!
+   DO it = 1, nbtr
+!  incloud scavenging and removal by large scale rain ! orig : ql_incl was replaced by 0.5e-3 kg/kg
+! the value 0.5e-3 kg/kg is from Giorgi and Chameides (1986), JGR
+! Liu (2001) proposed to use 1.5e-3 kg/kg
+
+    CALL lsc_scav(pdtphys,it,iflag_lscav,ql_incl,prfl,psfl,rneb,beta_fisrt,  &
+                  beta_v1,pplay,paprs,t_seri,tr_seri,d_tr_insc,   &
+                  d_tr_bcscav,d_tr_evapls,qPrls)
+
+!large scale scavenging tendency
+   DO k = 1, klev
+    DO i = 1, klon
+    d_tr_ls(i,k,it)=d_tr_insc(i,k,it)+d_tr_bcscav(i,k,it)+d_tr_evapls(i,k,it)
+    tr_seri(i,k,it)=tr_seri(i,k,it)+d_tr_ls(i,k,it)
+    ENDDO
+   ENDDO
+     CALL minmaxqfi(tr_seri(:,:,it),0.,1.e33,'lsc scav it = '//solsym(it))
+   END DO  !tr
+
+ ELSE IF (iflag_lscav .EQ. 2) THEN ! frac_impa, frac_nucl
+! *********   modified  old version
+
+     d_tr_lessi_nucl(:,:,:) = 0. 
+     d_tr_lessi_impa(:,:,:) = 0.
+     flestottr(:,:,:) = 0. 
+! Tendance des aerosols nuclees et impactes 
+     DO it = 1, nbtr
+        IF (aerosol(it)) THEN
+        his_dh(:)=0.
+           DO k = 1, klev
+              DO i = 1, klon
+!PhH
+              zrho(i,k)=pplay(i,k)/t_seri(i,k)/RD
+              zdz(i,k)=(paprs(i,k)-paprs(i,k+1))/zrho(i,k)/RG
+!
+              END DO
+           END DO
+
+          DO k=klev-1, 1, -1
+            DO i=1, klon
+!             d_tr_ls(i,k,it)=tr_seri(i,k,it)*(frac_impa(i,k)*frac_nucl(i,k)-1.)
+             dx=d_tr_ls(i,k,it)
+             his_dh(i)=his_dh(i)-dx*zrho(i,k)*zdz(i,k)/pdtphys !  kg/m2/s
+             evaplsc = prfl(i,k) - prfl(i,k+1) + psfl(i,k) - psfl(i,k+1)
+! Evaporation Partielle -> Liberation Partielle 0.5*evap
+            IF ( evaplsc .LT.0..and.abs(prfl(i,k+1)+psfl(i,k+1)).gt.1.e-10) THEN
+                evaplsc = (-evaplsc)/(prfl(i,k+1)+psfl(i,k+1))
+! evaplsc est donc positif, his_dh(i) est positif
+!--------------  
+             d_tr_evapls(i,k,it)=0.5*evaplsc*(d_tr_lessi_nucl(i,k+1,it) &
+                                  +d_tr_lessi_impa(i,k+1,it))
+!-------------   d_tr_evapls(i,k,it)=-0.5*evaplsc*(d_tr_lsc(i,k+1,it))
+             beta=0.5*evaplsc
+              if ((prfl(i,k)+psfl(i,k)).lt.1.e-10) THEN
+               beta=1.0*evaplsc
+              endif
+            dx=beta*his_dh(i)/zrho(i,k)/zdz(i,k)*pdtphys
+            his_dh(i)=(1.-beta)*his_dh(i)   ! tracer from
+            d_tr_evapls(i,k,it)=dx
+            ENDIF
+            d_tr_ls(i,k,it)=tr_seri(i,k,it)*(frac_impa(i,k)*frac_nucl(i,k)-1.) &
+                            +d_tr_evapls(i,k,it)
+
+!--------------
+                 d_tr_lessi_nucl(i,k,it) = d_tr_lessi_nucl(i,k,it) +    &
+                      ( 1 - frac_nucl(i,k) )*tr_seri(i,k,it)
+                 d_tr_lessi_impa(i,k,it) = d_tr_lessi_impa(i,k,it) +    &
+                      ( 1 - frac_impa(i,k) )*tr_seri(i,k,it)
+!
+! Flux lessivage total 
+                 flestottr(i,k,it) = flestottr(i,k,it) -   &
+                      ( d_tr_lessi_nucl(i,k,it)   +        &
+                      d_tr_lessi_impa(i,k,it) ) *          &
+                      ( paprs(i,k)-paprs(i,k+1) ) /        &
+                      (RG * pdtphys)
+!! Mise a jour des traceurs due a l'impaction,nucleation 
+!                 tr_seri(i,k,it)=tr_seri(i,k,it)*frac_impa(i,k)*frac_nucl(i,k)
+!!  calcul de la tendance liee au lessivage stratiforme
+!                 d_tr_ls(i,k,it)=tr_seri(i,k,it)*&
+!                                (1.-1./(frac_impa(i,k)*frac_nucl(i,k)))
+!--------------
+              END DO
+           END DO
+        END IF
+     END DO
+! *********   end modified old version
+
+ ELSE IF (iflag_lscav .EQ. 1) THEN ! frac_impa, frac_nucl
+! *********    old version
+
      d_tr_lessi_nucl(:,:,:) = 0. 
      d_tr_lessi_impa(:,:,:) = 0.
@@ -412,5 +675,8 @@
      END DO
      
-  END IF ! lessivage
+! *********   end old version
+  ENDIF  !  iflag_lscav . EQ. 1, 2, 3 or 4
+!
+  END IF !  lessivage
 
 !=============================================================
Index: LMDZ5/branches/testing/libf/phylmd/readaerosol_interp.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/readaerosol_interp.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/readaerosol_interp.F90	(revision 1750)
@@ -20,4 +20,5 @@
   USE write_field_phy
   USE phys_cal_mod
+  USE pres2lev_mod
 
   IMPLICIT NONE
Index: LMDZ5/branches/testing/libf/phylmd/surf_land_bucket_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/surf_land_bucket_mod.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/surf_land_bucket_mod.F90	(revision 1750)
@@ -24,4 +24,5 @@
     USE cpl_mod
     USE dimphy
+    USE comgeomphy
     USE mod_grid_phy_lmdz
     USE mod_phys_lmdz_para
@@ -97,4 +98,7 @@
 ! calculate constants
     CALL calbeta(dtime, is_ter, knon, snow, qsol, beta, capsol, dif_grnd)
+    if (type_veget=='betaclim') then
+       CALL calbeta_clim(knon,jour,rlatd(knindex(:)),beta)
+    endif
        
 ! calculate temperature, heat capacity and conduction flux in soil
@@ -107,4 +111,7 @@
     ELSE 
        cal(:) = RCPD * capsol(:)
+       IF (klon_glo .EQ. 1) THEN
+         cal(:) = 0.
+       ENDIF
     ENDIF
     
Index: LMDZ5/branches/testing/libf/phylmd/surface_data.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/surface_data.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/surface_data.F90	(revision 1750)
@@ -9,4 +9,5 @@
   
   LOGICAL, SAVE          :: ok_veget      ! true for use of vegetation model ORCHIDEE
+  CHARACTER(len=10), SAVE :: type_veget    ! orchidee/y/bucket/n/betaclim
   !$OMP THREADPRIVATE(ok_veget)
 
Index: LMDZ5/branches/testing/libf/phylmd/thermcellV0_main.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/thermcellV0_main.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/thermcellV0_main.F90	(revision 1750)
@@ -519,7 +519,7 @@
 !------------------------------------------------------------------
 
-      call thermcell_dq(ngrid,nlay,ptimestep,fm0,entr0,masse,  &
+      call thermcell_dq(ngrid,nlay,1,ptimestep,fm0,entr0,masse,  &
      &                    zthl,zdthladj,zta,lev_out)
-      call thermcell_dq(ngrid,nlay,ptimestep,fm0,entr0,masse,  &
+      call thermcell_dq(ngrid,nlay,1,ptimestep,fm0,entr0,masse,  &
      &                   po,pdoadj,zoa,lev_out)
 
@@ -561,7 +561,7 @@
 
 ! calcul purement conservatif pour le transport de V
-         call thermcell_dq(ngrid,nlay,ptimestep,fm0,entr0,masse  &
+         call thermcell_dq(ngrid,nlay,1,ptimestep,fm0,entr0,masse  &
      &    ,zu,pduadj,zua,lev_out)
-         call thermcell_dq(ngrid,nlay,ptimestep,fm0,entr0,masse  &
+         call thermcell_dq(ngrid,nlay,1,ptimestep,fm0,entr0,masse  &
      &    ,zv,pdvadj,zva,lev_out)
       endif
Index: LMDZ5/branches/testing/libf/phylmd/thermcell_dq.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/thermcell_dq.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/thermcell_dq.F90	(revision 1750)
@@ -1,3 +1,3 @@
-      subroutine thermcell_dq(ngrid,nlay,ptimestep,fm,entr,  &
+      subroutine thermcell_dq(ngrid,nlay,impl,ptimestep,fm,entr,  &
      &           masse,q,dq,qa,lev_out)
       implicit none
@@ -10,7 +10,12 @@
 !   calcul du dq/dt une fois qu'on connait les ascendances
 !
+! Modif 2013/01/04 (FH hourdin@lmd.jussieu.fr)
+!  Introduction of an implicit computation of vertical advection in
+!  the environment of thermal plumes in thermcell_dq
+!  impl =     0 : explicit, 1 : implicit, -1 : old version
+!
 !=======================================================================
 
-      integer ngrid,nlay
+      integer ngrid,nlay,impl
 
       real ptimestep
@@ -28,6 +33,5 @@
       real cfl
 
-      real qold(ngrid,nlay)
-      real ztimestep
+      real qold(ngrid,nlay),fqa(ngrid,nlay+1)
       integer niter,iter
       CHARACTER (LEN=20) :: modname='thermcell_dq'
@@ -35,4 +39,10 @@
 
 
+! Old explicite scheme
+      if (impl==-1) then
+         call thermcell_dq_o(ngrid,nlay,ptimestep,fm,entr,  &
+     &           masse,q,dq,qa,lev_out)
+         return
+      endif
 
 ! Calcul du critere CFL pour l'advection dans la subsidence
@@ -50,19 +60,7 @@
       enddo
 
-!IM 090508     print*,'CFL CFL CFL CFL ',cfl
-
-#undef CFL
-#ifdef CFL
-! On subdivise le calcul en niter pas de temps.
-      niter=int(cfl)+1
-#else
-      niter=1
-#endif
-
-      ztimestep=ptimestep/niter
       qold=q
 
 
-do iter=1,niter
       if (prt_level.ge.1) print*,'Q2 THERMCEL_DQ 0'
 
@@ -88,4 +86,151 @@
       enddo
 
+! Computation of tracer concentrations in the ascending plume
+      do ig=1,ngrid
+         qa(ig,1)=q(ig,1)
+      enddo
+
+      do k=2,nlay
+         do ig=1,ngrid
+            if ((fm(ig,k+1)+detr(ig,k))*ptimestep.gt.  &
+     &         1.e-5*masse(ig,k)) then
+         qa(ig,k)=(fm(ig,k)*qa(ig,k-1)+entr(ig,k)*q(ig,k))  &
+     &         /(fm(ig,k+1)+detr(ig,k))
+            else
+               qa(ig,k)=q(ig,k)
+            endif
+            if (qa(ig,k).lt.0.) then
+!               print*,'qa<0!!!'
+            endif
+            if (q(ig,k).lt.0.) then
+!               print*,'q<0!!!'
+            endif
+         enddo
+      enddo
+
+! Plume vertical flux
+      do k=2,nlay-1
+         fqa(:,k)=fm(:,k)*qa(:,k-1)
+      enddo
+      fqa(:,1)=0. ; fqa(:,nlay)=0.
+
+
+! Trace species evolution
+   if (impl==0) then
+      do k=1,nlay-1
+         q(:,k)=q(:,k)+(fqa(:,k)-fqa(:,k+1)-fm(:,k)*q(:,k)+fm(:,k+1)*q(:,k+1)) &
+     &               *ptimestep/masse(:,k)
+      enddo
+   else
+      do k=nlay-1,1,-1
+         q(:,k)=(masse(:,k)*q(:,k)/ptimestep+fqa(:,k)-fqa(:,k+1)+fm(:,k+1)*q(:,k+1)) &
+     &               /(fm(:,k)+masse(:,k)/ptimestep)
+      enddo
+   endif
+
+! Tendencies
+      do k=1,nlay
+         do ig=1,ngrid
+            dq(ig,k)=(q(ig,k)-qold(ig,k))/ptimestep
+            q(ig,k)=qold(ig,k)
+         enddo
+      enddo
+
+return
+end
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! Obsolete version kept for convergence with Cmip5 NPv3.1 simulations
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+      subroutine thermcell_dq_o(ngrid,nlay,ptimestep,fm,entr,  &
+     &           masse,q,dq,qa,lev_out)
+      implicit none
+
+#include "iniprint.h"
+!=======================================================================
+!
+!   Calcul du transport verticale dans la couche limite en presence
+!   de "thermiques" explicitement representes
+!   calcul du dq/dt une fois qu'on connait les ascendances
+!
+!=======================================================================
+
+      integer ngrid,nlay
+
+      real ptimestep
+      real masse(ngrid,nlay),fm(ngrid,nlay+1)
+      real entr(ngrid,nlay)
+      real q(ngrid,nlay)
+      real dq(ngrid,nlay)
+      integer lev_out                           ! niveau pour les print
+
+      real qa(ngrid,nlay),detr(ngrid,nlay),wqd(ngrid,nlay+1)
+
+      real zzm
+
+      integer ig,k
+      real cfl
+
+      real qold(ngrid,nlay)
+      real ztimestep
+      integer niter,iter
+      CHARACTER (LEN=20) :: modname='thermcell_dq'
+      CHARACTER (LEN=80) :: abort_message
+
+
+
+! Calcul du critere CFL pour l'advection dans la subsidence
+      cfl = 0.
+      do k=1,nlay
+         do ig=1,ngrid
+            zzm=masse(ig,k)/ptimestep
+            cfl=max(cfl,fm(ig,k)/zzm)
+            if (entr(ig,k).gt.zzm) then
+               print*,'entr dt > m ',entr(ig,k)*ptimestep,masse(ig,k)
+               abort_message = ''
+               CALL abort_gcm (modname,abort_message,1)
+            endif
+         enddo
+      enddo
+
+!IM 090508     print*,'CFL CFL CFL CFL ',cfl
+
+#undef CFL
+#ifdef CFL
+! On subdivise le calcul en niter pas de temps.
+      niter=int(cfl)+1
+#else
+      niter=1
+#endif
+
+      ztimestep=ptimestep/niter
+      qold=q
+
+
+do iter=1,niter
+      if (prt_level.ge.1) print*,'Q2 THERMCEL_DQ 0'
+
+!   calcul du detrainement
+      do k=1,nlay
+         do ig=1,ngrid
+            detr(ig,k)=fm(ig,k)-fm(ig,k+1)+entr(ig,k)
+!           print*,'Q2 DQ ',detr(ig,k),fm(ig,k),entr(ig,k)
+!test
+            if (detr(ig,k).lt.0.) then
+               entr(ig,k)=entr(ig,k)-detr(ig,k)
+               detr(ig,k)=0.
+!               print*,'detr2<0!!!','ig=',ig,'k=',k,'f=',fm(ig,k),
+!     s         'f+1=',fm(ig,k+1),'e=',entr(ig,k),'d=',detr(ig,k)
+            endif
+            if (fm(ig,k+1).lt.0.) then
+!               print*,'fm2<0!!!'
+            endif
+            if (entr(ig,k).lt.0.) then
+!               print*,'entr2<0!!!'
+            endif
+         enddo
+      enddo
+
 !   calcul de la valeur dans les ascendances
       do ig=1,ngrid
Index: LMDZ5/branches/testing/libf/phylmd/thermcell_main.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/thermcell_main.F90	(revision 1707)
+++ LMDZ5/branches/testing/libf/phylmd/thermcell_main.F90	(revision 1750)
@@ -22,4 +22,5 @@
 
       USE dimphy
+      USE ioipsl
       USE comgeomphy , ONLY:rlond,rlatd
       IMPLICIT NONE
@@ -44,5 +45,15 @@
 !     4. un detrainement
 !
+! Modif 2013/01/04 (FH hourdin@lmd.jussieu.fr)
+!    Introduction of an implicit computation of vertical advection in
+!    the environment of thermal plumes in thermcell_dq
+!    impl =     0 : explicit, 1 : implicit, -1 : old version
+!    controled by iflag_thermals =
+!       15, 16 run with impl=-1 : numerical convergence with NPv3
+!       17, 18 run with impl=1  : more stable
+!    15 and 17 correspond to the activation of the stratocumulus "bidouille"
+!
 !=======================================================================
+
 
 !-----------------------------------------------------------------------
@@ -79,4 +90,7 @@
 
       integer icount
+
+      integer, save :: dvdq=1,dqimpl=-1
+!$OMP THREADPRIVATE(dvdq,dqimpl)
       data icount/0/
       save icount
@@ -247,4 +261,15 @@
 
       if (debut)  then
+!        call getin('dvdq',dvdq)
+!        call getin('dqimpl',dqimpl)
+
+         if (iflag_thermals==15.or.iflag_thermals==16) then
+            dvdq=0
+            dqimpl=-1
+         else
+            dvdq=1
+            dqimpl=1
+         endif
+
          fm0=0.
          entr0=0.
@@ -593,7 +618,7 @@
 !------------------------------------------------------------------
 
-      call thermcell_dq(ngrid,nlay,ptimestep,fm0,entr0,masse,  &
+      call thermcell_dq(ngrid,nlay,dqimpl,ptimestep,fm0,entr0,masse,  &
      &                    zthl,zdthladj,zta,lev_out)
-      call thermcell_dq(ngrid,nlay,ptimestep,fm0,entr0,masse,  &
+      call thermcell_dq(ngrid,nlay,dqimpl,ptimestep,fm0,entr0,masse,  &
      &                   po,pdoadj,zoa,lev_out)
 
@@ -620,8 +645,5 @@
 
 !IM 090508  
-      if (1.eq.1) then
-!IM 070508 vers. _dq       
-!     if (1.eq.0) then
-
+      if (dvdq == 0 ) then
 
 ! Calcul du transport de V tenant compte d'echange par gradient
@@ -629,5 +651,6 @@
 
          call thermcell_dv2(ngrid,nlay,ptimestep,fm0,entr0,masse  &
-     &    ,fraca,zmax  &
+!    &    ,fraca*dvdq,zmax &
+     &    ,fraca,zmax &
      &    ,zu,zv,pduadj,pdvadj,zua,zva,lev_out)
 
@@ -635,8 +658,9 @@
 
 ! calcul purement conservatif pour le transport de V
-         call thermcell_dq(ngrid,nlay,ptimestep,fm0,entr0,masse  &
+         call thermcell_dq(ngrid,nlay,dqimpl,ptimestep,fm0,entr0,masse  &
      &    ,zu,pduadj,zua,lev_out)
-         call thermcell_dq(ngrid,nlay,ptimestep,fm0,entr0,masse  &
+         call thermcell_dq(ngrid,nlay,dqimpl,ptimestep,fm0,entr0,masse  &
      &    ,zv,pdvadj,zva,lev_out)
+
       endif
 
